#
#	SCCS: @(#)msc+mks.mk	1.2 (97/07/09)
#
#	UniSoft Ltd., London, England
#
# (C) Copyright 1996 X/Open Company Limited
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
# A copy of the end-user licence agreement is contained in the file
# Licence which accompanies this distribution.
# 
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
# ************************************************************************
#
# SCCS:   	@(#)msc+mks.mk	1.2 97/07/09 TETware release 3.2
# NAME:		msc+mks.mk
# PRODUCT:	TETware
# AUTHOR:	Andrew Dingwall, UniSoft Ltd.
# DATE CREATED:	September 1996
#
# DESCRIPTION:
#	common definitions file for Microsoft Visual C++ and the
#	MKS toolkit for use on Windows NT
#
#	this file is derived from template.mk
#
#	this file is part of the "defined build environment" for TETware
#	on Windows NT and should not normally need to be altered
#
# MODIFICATIONS:
#
#	Geoff Clare, UniSoft Ltd., July 1997
#	Changes to support NT threads.
# 
# ************************************************************************

# tccd can be started:
#	from /etc/inittab (SYSV systems)
#	from /etc/inetd (BSD4.3 style)
#	from /etc/rc (BSD4.2 style)
#	interactively by a user
#
# inittab systems should include -DINITTAB in DTET_CDEFS below
# inetd systems should include -DINETD in DTET_CDEFS below

# TCCD specifies the name by which tccd is to be known; on Unix systems
# this should be in.tccd if you define INETD, otherwise it should be tccd
TCCD = tccd

# parallel build indicator (mainly for DYNIX)
# leave this blank for most systems
P =

# make utilities - these don't usually change
MAKE = make
SHELL = sh

# TET and DTET defines; these are added to CDEFS in individual makefiles
#	TET_CDEFS are used to compile TET-derived code
#	these should include -D_POSIX_SOURCE and a value for NSIG (the number
#	of signals on your system)
#	also, you may want to define TET_SIG_IGNORE and TET_SIG_LEAVE here
#	for example:
#		TET_CDEFS = -D_POSIX_SOURCE -DNSIG=32
#	DTET_CDEFS are used to compile DTET and networking code
#
TET_CDEFS =
DTET_CDEFS = -DINETD

# sgs component definitions and flags
# CC - the name of the C compiler
CC = cc
# CDEFS may be passed to lint and cc, COPTS to cc only
# CDEFS and COPTS are used to construct CFLAGS for use in make's built-in rules
CDEFS = -I$(INC) -I$(DINC) -DPROTOTYPES
COPTS = -O -Ze
# THR_COPTS is used instead of COPTS when compiling the thread API library
THR_COPTS = -MD -O -Ze
# LDFLAGS - loader flags used by make's built-in rules
LDFLAGS =
# C_PLUS - the name of the C++ compiler
C_PLUS = $(CC)
# C_SUFFIX - suffix for C++ source files
C_SUFFIX = cpp
# if your system's a.out format includes a .comment section that can be
# compressed by using mcs -c, set MCS to mcs; otherwise set MCS to @:
MCS = :
# AR is the name of the archive library maintainer
AR = ar
# LORDER and TSORT are the names for lorder and tsort, used to order an archive
# library; if they don't exist on your system or don't work, set LORDER to echo
# and TSORT to cat
LORDER = echo
TSORT = cat
# if your system needs ranlib run after an archive library is updated,
# set RANLIB to ranlib; otherwise set RANLIB to @:
RANLIB = :

# add : and = to the list of characters which will cause MKS make to invoke
# a shell when a rule is executed
SHELLMETAS += :=

# tell MKS make only to use explicit dependencies when building a library
.NOAUTODEPEND:

# Source and object file suffixes that are understood by the sgs
# on this platform.
# Note that all these suffixes may include an initial dot - this convention
# permits an empty suffix to be specified.
# O - suffix that denotes an object file (e.g.: .obj or .o)
O = .obj
# A - suffix that denotes an archive library (e.g.: .lib or .a)
A = .lib
# E - suffix that denotes an executable file (e.g.: .exe or nothing)
E = .exe

# system libraries for inclusion at the end of cc command line
SYSLIBS = wsock32.lib advapi32.lib

# lint libraries for inclusion at the end of lint command line
LINTLIBS =

# Definitions for xpg3sh API and TCM
#
# standard signal numbers - change to correct numbers for your system
# SIGHUP, SIGINT, SIGQUIT, SIGILL, SIGABRT, SIGFPE, SIGPIPE, SIGALRM,
# SIGTERM, SIGUSR1, SIGUSR2, SIGTSTP, SIGCONT, SIGTTIN, SIGTTOU
# 
# Example: SH_STD_SIGNALS = 1 2 3 4 6 8 13 14 15 16 17 25 26 27 28
SH_STD_SIGNALS = 2 14

# signals that are always unhandled - change for your system
# May need to include SIGSEGV and others if the shell can't trap them
# SIGKILL, SIGCHLD, SIGSTOP, (SIGSEGV, ...)
#
# Example: SH_SPEC_SIGNALS = 9 18 24 11
SH_SPEC_SIGNALS = 1 3 4 5 6 7 8 9 10 11 12 13

# highest shell signal number plus one
# May need to be less than the value specified with -DNSIG in TET_CDEFS
# if the shell can't trap higher signal numbers
SH_NSIG = 15

# Definitions for ksh API and TCM
KSH_STD_SIGNALS = $(SH_STD_SIGNALS)
KSH_SPEC_SIGNALS = $(SH_SPEC_SIGNALS)
KSH_NSIG = $(SH_NSIG)

