/*
 *      SCCS:  @(#)prerror.c	1.8 (97/07/21) 
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

#ifndef lint
static char sccsid[] = "@(#)prerror.c	1.8 (97/07/21) TETware release 3.2";
#endif

/************************************************************************

SCCS:   	@(#)prerror.c	1.8 97/07/21 TETware release 3.2
NAME:		prerror.c
PRODUCT:	TETware
AUTHOR:		Andrew Dingwall, UniSoft Ltd.
DATE CREATED:	April 1992

DESCRIPTION:
	error message formatting and printing function

MODIFICATIONS:
	Andrew Dingwall, UniSoft Ltd., July 1997
	added support the MT DLL version of the C runtime support library
	on Win32 systems


************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#ifndef TET_LITE	/* -START-LITE-CUT- */
#  ifdef _WIN32		/* -START-WIN32-CUT- */
#    include <winsock.h>
#  endif /* _WIN32 */	/* -END-WIN32-CUT- */
#endif /* !TET_LITE */	/* -END-LITE-CUT- */
#include "dtmac.h"
#include "dtetlib.h"

#ifndef _WIN32	/* -WIN32-CUT-LINE- */
extern char *SYS_ERRLIST[];
extern int SYS_NERR;
#endif		/* -WIN32-CUT-LINE- */

/*
**	tet_prerror() - format and print an error message
*/

void tet_prerror(fp, errnum, hdr, file, line, s1, s2)
FILE *fp;
int errnum, line;
char *hdr, *file, *s1, *s2;
{
	(void) fprintf(fp, "%s (%s, %d): %s", hdr, file, line, s1);
	if (s2 && *s2)
		(void) fprintf(fp, " %s", s2);
	if (errnum > 0 && errnum < SYS_NERR)
		(void) fprintf(fp, ": %s", SYS_ERRLIST[errnum]);
#ifndef TET_LITE	/* -START-LITE-CUT- */
#  ifdef _WIN32		/* -START-WIN32-CUT- */
	else if (errnum >= WSABASEERR)
		(void) fprintf(fp, ": %s", tet_wsaerrmsg(errnum));
#  endif /* _WIN32 */	/* -END-WIN32-CUT- */
#endif /* !TET_LITE */	/* -END-LITE-CUT- */
	(void) putc('\n', fp);
	(void) fflush(fp);

	errno = 0;
}

